#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Box.H>
#include <FL/Fl_Button.H>
#include <FL/Fl_Output.H>
#include <FL/Fl_Timer.H>
#include <FL/Fl_Multiline_Output.H>
#include <FL/fl_message.H>

#include "vr-tris.h"


static void cb_quit_button(void) {
  timerhold=ctimer->value();
  if(paused !=1){
     ctimer->value(0.0);
  }
  
  if(started==1){;
     if(fl_ask("Really quit?")){
        if(score>xlines){
        	filep = fopen(filestring,"w");
		fprintf(filep,"%d\n", score);
		fclose(filep);
	}
        main_window->hide();
        delete main_window;
     }
  } else {main_window->hide();}

  if(paused !=1){
     ctimer->value(timerhold);
  }

}

static void cb_s_p_button() {
    
    if (started == 0){
       preview_piece = new game_piece;
       preview_piece->show_as_preview();
       active_piece = new game_piece;
       active_piece->show_as_game();
       if(lines < 100){
          ctimer->value((1.5-(.1*((lines/10) - ((lines % 10)/10)))));
       } else {
          ctimer->value(.05);
       }
       started =1;
       paused =0;
       return;
    }else{
      timerhold=ctimer->value();
      if(paused !=1){
         ctimer->value(0.0);
      }
      fl_message("Game Paused.\nHit \"OK\" to continue.");
      if(paused !=1){
         ctimer->value(timerhold);
      }

 /*      if(b->label()=="Resume"){
          b->label("Pause");
	  //fl_resume_timer(ctimer);
          ctimer->value(timerhold);
	  paused=0;
       } else {
          b->label("Resume");
	  //fl_suspend_timer(ctimer);
	  timerhold=ctimer->value();
          ctimer->value(0);
	  paused=1;
       }
*/
    }
    
}

static void cb_down_button(void) {
   if(paused !=1){
    if(active_piece->move_down()){
        active_piece->show_as_game();
    } else {
        active_piece->drop_piece();
	new_pieces();
	
    }
   }
}

/*static*/ void cb_drop_button(void) {
    int dropped = 0;
    if(paused !=1){
    paused =1;
    while(dropped ==0){
      if(active_piece->move_down()){
        active_piece->show_as_game();
      } else {
        active_piece->drop_piece();
	dropped = 1;
	new_pieces();
      }
    }
    paused =0;
    if(lines < 100){
          ctimer->value((1.5-(.1*((lines/10) - ((lines % 10)/10)))));
       } else {
          ctimer->value(.05);
       }


//    ctimer->value((1.5-(.1*((lines/10) - ((lines % 10)/10)))));
    }
}

static void cb_left_button(void) {
   if(paused !=1){
    if(active_piece->move_left()){
        active_piece->show_as_game();
    } 
   }
}

static void cb_rotate_button(void) {
   if(paused !=1){
    active_piece->rotate();
   }
}

static void cb_right_button(void) {
   if(paused !=1){
    if(active_piece->move_right()){
        active_piece->show_as_game();
    }
   }
}

void cb_help_button(void) {
   timerhold=ctimer->value();
   if(paused !=1){
      ctimer->value(0.0);
   }

   
   if(paused !=1){
       ctimer->value(timerhold);
   }
}

void piece_style(void) {
   
   if(boxstyle == FL_EMBOSSED_BOX){
      boxstyle = FL_ROUNDED_BOX;
   } else {
      boxstyle = FL_EMBOSSED_BOX;
   };
   
//   toggle_button->box(boxstyle);

}

static void cb_ctimer(Fl_Timer *t, void*) {
//    t->value(1.5-(.15*((lines/10) - ((lines % 10)/10))));
       if(lines < 100){
          t->value((1.5-(.1*((lines/10) - ((lines % 10)/10)))));
       } else {
          t->value(.05);
       }
    
    if(active_piece->move_down()){
        active_piece->show_as_game();
    } else {
        active_piece->drop_piece();
	new_pieces();
    }
}

void new_pieces(void){
    delete active_piece;
    active_piece = new game_piece;
    for (int x = 0; x < 4; x++)
      for (int y = 0; y < 4; y++)
        active_piece->matrix[x][y] = preview_piece->matrix[x][y];
    active_piece->piecetype = preview_piece->piecetype;
    active_piece->show_as_game();
    delete preview_piece;
    preview_piece = new game_piece;
    preview_piece->show_as_preview();
       
    if(game_over==1){
           ctimer->value(0.0);
	   char overstring[100];
	    
	   if(score>xlines){
        		filep = fopen(filestring,"w");
			fprintf(filep,"%d\n", score);
			fclose(filep);
			xlines = score;
	   }
	   
	   sprintf(overstring, " Game over!\n your score: %d\n high score: %d\n Play again?", score, xlines);
           if(!fl_ask(overstring)){
             exit(0);
	   }
	   for (int i=0; i<25; i++){
             for (int j=0; j<10; j++){
              if(i<20){ 
	        tiles[i][j]->box(FL_FLAT_BOX);
		tiles[i][j]->color(fl_gray_ramp(22));
		tiles[i][j]->redraw();
              }
		board_matrix[i][j]=0;
	   }
	   lines=0;
	   lines_score->label("S: 0");
	   level_box->label("L: 0");
	   filep = fopen(filestring,"r");
	   if (filep){
		fscanf(filep, "%d", &xlines);
		//printf("score: %d\n", x);
		fclose(filep);
		sprintf(maxlines,"H: %3d",xlines);
	  	high_score->label(maxlines);
           }
	   
	   
       }
       delete preview_piece;
       preview_piece = new game_piece;
       preview_piece->show_as_preview();
       delete active_piece;
       active_piece = new game_piece;
       active_piece->show_as_game();
       if(lines < 100){
          ctimer->value((1.5-(.1*((lines/10) - ((lines % 10)/10)))));
       } else {
          ctimer->value(.05);
       }
//       ctimer->value((1.5-(.1*((lines/10) - ((lines % 10)/10)))));
       started =1;
       paused =0;
    }
}

Window::Window( int w , int h , const char* l ) : Fl_Window( w , h , l ) { 
            
};
//
int Window::handle( int e ) { 
            
        int ret = Fl_Group::handle( e );
            
        if( e == FL_KEYDOWN )
                keyBase( Fl::event_key() );
            
        return( ret ); // (1=no Esc)
            
}
//
void Window::keyBase( int key ) { 
            
        if( !paused && started )
        {   
                if( key == FL_Right ) cb_right_button();
                if( key == FL_Left ) cb_left_button();
                if( key == FL_Down ) cb_down_button();
                if( key == FL_Up ) cb_rotate_button();
                    
                if( key == FL_Enter  || key == ' ' || key == FL_KP_Enter) { cb_drop_button(); }
                    
        }   
       if (key == FL_Enter || key == FL_KP_Enter || key == ' ')
         if (!started)
           cb_s_p_button();
}
//

int main(void) {

       printf("VR-Tris v0.20\nwww.firemouth.org/vr-tris\n\nChris Dahl 2001\nchris@firemouth.org\n");
       srand(time(NULL));
       lines = 0;

/**** Makes the main game window ******************************************/
       // game window
       {Window *o = main_window = new Window(230,310,"VR-Tris");  
       w=o;
       o->color( FL_LIGHT2 );

      // o->clear_border();
       
#define BOX_SIZE 13
       // score box
       lines_score = new Fl_Box(170, 90, 50, 15, "Score:");
       lines_score->box(FL_PLASTIC_DOWN_BOX);
       lines_score->color((Fl_Color)10);
       lines_score->label("S: 0");
       
       // level box
       level_box = new Fl_Box(170, 63, 50, 15, "Level:");
       level_box->box(FL_PLASTIC_DOWN_BOX);
       level_box->color((Fl_Color)10);
       level_box->label("L:  0");
       
       // high score box
       high_score = new Fl_Box(170, 117, 50, 15, "Highscore:");
       high_score->box(FL_PLASTIC_DOWN_BOX);
       high_score->color((Fl_Color)12);
       high_score->label("H:  0");

       // tile box
       Fl_Box *game_box = new Fl_Box(3, 3, 10 * BOX_SIZE + 4, 20 * BOX_SIZE +4); // game box for tiles
       game_box->box(FL_DOWN_BOX);
       game_box->color(fl_gray_ramp(21));
    
       // tiles for tile box
       for (int i=0; i<20; i++){
           for (int j=0; j<10; j++){
                tiles[i][j]= new Fl_Box(20,20,BOX_SIZE,BOX_SIZE);
	        tiles[i][j]->position((BOX_SIZE*j+5),(BOX_SIZE*i+5));
              //if(i<20){ 
	        tiles[i][j]->box(FL_FLAT_BOX);
		tiles[i][j]->color(fl_gray_ramp(22));
              //}
		board_matrix[i][j]=0; 
	   }
       }
       
       // toggle style button
 //      Fl_Button *toggle_button = new Fl_Button(100, 25, 9, 9);
 //      toggle_button->callback((Fl_Callback*)piece_style);  

       
       // preview box
       Fl_Box *preview_box = new Fl_Box(170, 17, 36, 32, "VR-Tris");
       preview_box->box(FL_DOWN_BOX);
       preview_box->color(fl_gray_ramp(21));
       preview_box->selection_color(7);
       preview_box->labeltype(FL_EMBOSSED_LABEL);
       preview_box->labelsize(12);
       preview_box->align(FL_ALIGN_TOP);
       
       // tiles for preview box
       for (int i=0; i<3; i++){
           for (int j=0; j<4; j++){
                p_tiles[i][j]= new Fl_Box(20,20,8,8);
	        p_tiles[i][j]->position((8*j+172),(8*i+21));
	     //if(i<3){ 
                p_tiles[i][j]->box(FL_FLAT_BOX);
		p_tiles[i][j]->color(fl_gray_ramp(22));
//             }
	   }
       }
       
       //for (int j=0; j<4; j++){
        //    p_tiles[3][j]->hide();
	//    }
       
       // timer
       ctimer = new Fl_Timer(FL_HIDDEN_TIMER, 2, 2, 2, 2, "hi");
       ctimer->callback((Fl_Callback*)cb_ctimer);
       
       // finish building window
       o->end();
       }
       
  	/************************************************/     
  

		
	sprintf(filestring,"%s%s",getenv("HOME"),"/.vrtris");

	filep = fopen(filestring,"r");
	if (filep){
		fscanf(filep, "%d", &xlines);
		//printf("score: %d\n", x);
		fclose(filep);
		sprintf(maxlines,"H: %3d",xlines);
	  	high_score->label(maxlines);
      	}
       
       /************************************************/
       w->show();
//       w->fullscreen();

/**** End of main window creation ******************************************/
    
      return Fl::run();

}


