#include <stdlib.h>
#include <stdio.h>
#include <time.h>


/**** variables ****/

/**************************************************************************/
//
/*      Deklaration of objekt - the interface. (.h-file..)*/
//
class Window : public Fl_Window {

        public:
                Window( int w , int h , const char *l=0 ) ;
                void keyBase( int );
        
        private:
                int handle( int );

};


Window *main_window=(Window *)0;

Fl_Button *left_button=(Fl_Button *)0;

Fl_Button *rotate_button=(Fl_Button *)0;

Fl_Button *right_button=(Fl_Button *)0;

Fl_Button *toggle_button=(Fl_Button *)0;

Fl_Box *game_box=(Fl_Box *)0;

Fl_Button *down_button=(Fl_Button *)0;

Fl_Button *drop_button=(Fl_Button *)0;

Fl_Box *preview_box=(Fl_Box *)0;

// Fl_Box* tiles[25][10]=(Fl_Box *)0;    /* tiles */
// Fl_Box* p_tiles[4][4]=(Fl_Box *)0;    /* preview tiles */

Fl_Box* tiles[20][10];    /* tiles */
Fl_Box* p_tiles[3][4];    /* preview tiles */

Fl_Button *quit_button=(Fl_Button *)0;

Fl_Button *pause_button=(Fl_Button *)0;

Fl_Box *lines_score=(Fl_Box *)0;

Fl_Box *level_box = (Fl_Box *)0;

Fl_Box *high_score=(Fl_Box *)0;

Fl_Button *help_button=(Fl_Button *)0;

Fl_Box *tile_box=(Fl_Box *)0;

Fl_Timer *ctimer =(Fl_Timer *)0;         /* timer object */
/**************************************************************************/

/* shapes of pieces available */
int shapes[8][4][4]={{{0,0,0,0},  // blank
                     {0,0,0,0},
	 	     {0,0,0,0},
		     {0,0,0,0}},
		     
                     {{0,0,0,0},  //straight line
		     {0,0,0,0},
		     {1,1,1,1},
		     {0,0,0,0}},
		    
                     {{0,0,0,0},
		     {0,1,1,0},  //box
		     {0,1,1,0},
		     {0,0,0,0}},
		     		    
                     {{0,0,0,0},  // s cw
		     {0,1,1,0},
		     {1,1,0,0},
		     {0,0,0,0}},
		    
                     {{0,0,0,0},  // s ccw
		     {1,1,0,0},
		     {0,1,1,0},
		     {0,0,0,0}},
		    
                     {{0,0,0,0}, // l 
		     {0,0,1,0},
		     {1,1,1,0},
		     {0,0,0,0}},
		     
                     {{0,0,0,0}, //t
		     {1,1,1,0},
		     {0,1,0,0},
		     {0,0,0,0}},
		    
                     {{0,0,0,0},  /* l backwards */
		     {1,1,1,0},
		     {0,0,1,0},
		     {0,0,0,0}}};

//Fl_Box* tiles[25][10];    /* tiles */
//Fl_Box* p_tiles[4][4];    /* preview tiles */
//Fl_Timer* ctimer;         /* timer object */
//Fl_Output* lines_score;
//Fl_Output* high_score;
//Fl_Button* s_p_button;

int fl_ask(const char *, ...);

int game_over;
int h;
int started = 0;          /* is a game under way? */
int board_matrix[20][10]; /* 1,0 representation of tiles */
int lines;
int qnewgame;
float timerhold;
int paused = 1;
char slines[8];
char slevel[8];
char maxlines[8];
int score;

char st[8];
float st1;

char filestring[100];
FILE *filep;
int xlines = 0;
Window* w;

Fl_Boxtype boxstyle = FL_THIN_UP_BOX;
Fl_Color boxcolor = fl_gray_ramp(4);
//int boxcolor = 100;

// FL_ROUNDED_BOX
		    
/***************** game_piece class stuff *********************************/		    
class game_piece{
private:
   Fl_Color piececolor();
   
   
public:
   int matrix[4][4];  /* holds piece data */
   game_piece();
   ~game_piece();
   int drop_piece();
   int move_down();
   int move_left();
   int move_right();
   int rotate();
   int ok_to_move;
   int show_as_preview();
   int show_as_game();
   int x_offset, y_offset, nx_offset, ny_offset;  /* position information for piece */
   int piecetype;
};


/* game_piece class destructor */
game_piece::~game_piece()
{

};

/* game_piece class constructor called with no args */
game_piece::game_piece()
{

   int random = rand() % 7 + 1;
   piecetype = random;

   x_offset = 3;
   y_offset = 0;
   nx_offset = 0;
   ny_offset = 0;
   
   for(int r = 0; r<4; r++){
       for(int c = 0; c<4; c++){
           if(shapes[random][r][c] == 1){
              matrix[r][c]= 1;
	   } else {
	   matrix[r][c]=0;
	   }
       }
    }
     
}

/* show piece in preview area */
int game_piece::show_as_preview()
{
   for(int r = 0; r<3; r++){
       for(int c = 0; c<4; c++){
           if(matrix[r][c] == 1){
	      //if(r<3){ 
              p_tiles[r][c]->color(piececolor());
	      p_tiles[r][c]->box(boxstyle);
	      p_tiles[r][c]->redraw();
	      //}
	   } else {
	      //if(r<3){ 
	      p_tiles[r][c]->box(FL_FLAT_BOX);
              p_tiles[r][c]->color(fl_gray_ramp(22));
	      p_tiles[r][c]->redraw();
	      //}
	   }  
       }
   }
   return 0;
}

Fl_Color game_piece::piececolor()
{
  switch(piecetype) {
  case 0:
    return fl_rgb_color(0xff, 0, 0);
  case 1:
    return fl_rgb_color(0, 0xff, 0);
  case 2:
    return fl_rgb_color(0, 0, 0xff);
  case 3:
    return fl_rgb_color(0x66, 0, 0xff);
  case 4:
    return fl_rgb_color(0x45, 0x21, 0xb8);
  case 5:
    return fl_rgb_color(0, 0x7f, 0xff);
  case 6:
    return fl_rgb_color(0xff, 0xb9, 0x0f);
  case 7:
    return fl_rgb_color(0xcc, 0x00, 0x66);
  }
  return boxcolor;
}

/* show piece in game area */
int game_piece::show_as_game()
{
   game_over=0;
   for(int r = 0; r<4; r++){
       for(int c = 0; c<4; c++){
	   if(matrix[r][c] == 1){
	      if(board_matrix[r+y_offset][c+x_offset]==1){game_over=1;}
              tiles[r+y_offset][x_offset + c]->color(piececolor());
	      tiles[r+y_offset][x_offset + c]->box(boxstyle);
	      tiles[r+y_offset][x_offset + c]->redraw();
	   } 
       }
   }
   return 0;
}

/* attempt to move a piece down a square */
int game_piece::move_down()
{
   ok_to_move=1;
   
   for(int r = 0; r<4; r++){
       for(int c = 0; c<4; c++){
           if(matrix[r][c] == 1){
	      if((r+y_offset+1)>19){
	          ok_to_move=0;
		  }	      	      
	      else{
	           if(board_matrix[r+y_offset+1][c+x_offset]==1){
	           ok_to_move=0;
		  }
	      }
	   } 
	}
    }
    
    if(ok_to_move==1){
       for(int r = 0; r<4; r++){
         for(int c = 0; c<4; c++){
	   if(matrix[r][c] == 1){
	        tiles[r+y_offset][x_offset + c]->box(FL_FLAT_BOX);
		tiles[r+y_offset][x_offset + c]->color(fl_gray_ramp(22));
	        tiles[r+y_offset][x_offset + c]->redraw();
	   } 
         }
       }
       y_offset += 1;
    }
    return ok_to_move;
}

/* attempt to move a piece left a square */
int game_piece::move_left()
{
   ok_to_move=1;
   
   for(int r = 0; r<4; r++){
       for(int c = 0; c<4; c++){
           if(matrix[r][c] == 1){
	      if((c+x_offset-1)<0){ok_to_move=0;}	      	      
	      else{
	           if(board_matrix[r+y_offset][c+x_offset-1]==1){
	           ok_to_move=0;
		  }
	      }
	   } 
	}
    }
    
    if(ok_to_move==1){
       for(int r = 0; r<4; r++){
         for(int c = 0; c<4; c++){
	   if(matrix[r][c] == 1){
	        tiles[r+y_offset][x_offset + c]->box(FL_FLAT_BOX);
		tiles[r+y_offset][x_offset + c]->color(fl_gray_ramp(22));
	        tiles[r+y_offset][x_offset + c]->redraw();
	   } 
         }
       }
       x_offset += -1;
    }
    return ok_to_move;
}

/* attempt to move a piece right a square */
int game_piece::move_right()
{
   ok_to_move=1;
   
   for(int r = 0; r<4; r++){
       for(int c = 0; c<4; c++){
           if(matrix[r][c] == 1){
	      if((c+x_offset+1)>9){ok_to_move=0;}	      	      
	      else {
	            if(board_matrix[r+y_offset][c+x_offset+1]==1){
	            ok_to_move=0;
	            }
	      }
	   } 
	}
    }
    
    if(ok_to_move==1){
       for(int r = 0; r<4; r++){
         for(int c = 0; c<4; c++){
	   if(matrix[r][c] == 1){
	        tiles[r+y_offset][x_offset + c]->box(FL_FLAT_BOX);
		tiles[r+y_offset][x_offset + c]->color(fl_gray_ramp(22));
	        tiles[r+y_offset][x_offset + c]->redraw();
	   } 
         }
       }
       x_offset += 1;
    }
    return ok_to_move;
}

int game_piece::drop_piece()
{
   int lines_cleared = 0;
   for(int r = 0; r<4; r++){
       for(int c = 0; c<4; c++){
           if(matrix[r][c] == 1){
	      board_matrix[r+y_offset][c+x_offset]=1;
              tiles[r+y_offset][x_offset + c]->color(piececolor());
	      tiles[r+y_offset][x_offset + c]->box(boxstyle);
	        tiles[r+y_offset][x_offset + c]->redraw();
	   } 
       }
   }
   
   int row_full[20]; 
   int old_board_matrix[20][10];
   
   /* make a copy of the board matrix */
   for(int r = 0; r<20; r++){
       for(int c = 0; c<10; c++){
           old_board_matrix[r][c]=board_matrix[r][c];
       }
   }
   
   int new_row_full;
   int r = 19;
   while(r>=0){
       	new_row_full=1;
       	for(int c = 0; c<10; c++){
           if(board_matrix[r][c] == 0){
	      new_row_full = 0;
	   } 
       	}
   	if(new_row_full==1){
	  lines_cleared++;
          for(int x = r; x>0; x--){
	      for(int c = 0; c<10; c++){
	          board_matrix[x][c]=board_matrix[x-1][c];
	      }
	  }
          for(int c = 0; c<10; c++){
	      board_matrix[0][c]=0;
	  }
	  lines++;
	  r++;
	  
        }
	r--;
   }
   
   /* compare board_matrix to the old one and update tiles accordingly */
   for(int r = 0; r<20; r++){
       for(int c = 0; c<10; c++){
           if(board_matrix[r][c] != old_board_matrix[r][c]) {
	      if(board_matrix[r][c]==1){
                tiles[r][c]->color(boxcolor);
	        tiles[r][c]->box(boxstyle);
	        tiles[r][c]->redraw();
	      }
	      if(board_matrix[r][c]==0){
	        tiles[r][c]->box(FL_FLAT_BOX);
		tiles[r][c]->color(fl_gray_ramp(22));
	        tiles[r][c]->redraw();
		}
	   } 
       }
   }

   score += (lines_cleared*lines_cleared)*((lines/10)+1);
   sprintf(slevel,"L: %3d",((lines/10)+1));
   sprintf(slines,"S: %3d",score);
   level_box->label(slevel);
   lines_score->label(slines);

   return 0;
}

int game_piece::rotate()
{
   int t_matrix[4][4];
   int ok_to_rotate =1;
   
   for(int r = 0; r<4; r++){
       for(int c = 0; c<4; c++){
           t_matrix[r][c] = matrix[c][3-r];
       }
   }
   
   for(int r = 0; r<4; r++){
       for(int c = 0; c<4; c++){
           if(t_matrix[r][c] == 1){
	      if((c+x_offset)<0){ok_to_rotate=0;}
	      if((c+x_offset)>9){ok_to_rotate=0;}
	      if((r+y_offset)>19){ok_to_rotate=0;}
	      if(board_matrix[r+y_offset][c+x_offset]==1){ok_to_rotate=0;}
	   }
       }
   }
   
   if(ok_to_rotate == 1){
   for(int r = 0; r<4; r++){
       for(int c = 0; c<4; c++){
	   if(matrix[r][c] == 1){
	        tiles[r+y_offset][x_offset + c]->box(FL_FLAT_BOX);
		tiles[r+y_offset][x_offset + c]->color(fl_gray_ramp(22));
	        tiles[r+y_offset][x_offset + c]->redraw();
	   }
	   if(t_matrix[r][c] == 1){
              tiles[r+y_offset][x_offset + c]->color(piececolor());
	      tiles[r+y_offset][x_offset + c]->box(boxstyle);

	        tiles[r+y_offset][x_offset + c]->redraw();
	   }
       }
   }
   for (int x = 0; x < 4; x++)
     for (int y = 0; y < 4; y++)
       matrix[x][y] = t_matrix[x][y];
   };
   
   return 0;
   
}
/**** end of game piece class ****/

void new_pieces(void);
game_piece *preview_piece;
game_piece *active_piece;
//Fl_Window* main_window;  /* main window */
